<?php

class Flossy_Customizer_Notify {

	private $recommended_actions;

	
	private $recommended_plugins;

	
	private static $instance;

	
	private $recommended_actions_title;

	
	private $recommended_plugins_title;

	
	private $dismiss_button;

	
	private $install_button_label;

	
	private $activate_button_label;

	
	private $flossy_deactivate_button_label;
	
	
	private $config;

	
	public static function init( $config ) {
		if ( ! isset( self::$instance ) && ! ( self::$instance instanceof Flossy_Customizer_Notify ) ) {
			self::$instance = new Flossy_Customizer_Notify;
			if ( ! empty( $config ) && is_array( $config ) ) {
				self::$instance->config = $config;
				self::$instance->setup_config();
				self::$instance->setup_actions();
			}
		}

	}

	
	public function setup_config() {

		global $flossy_customizer_notify_recommended_plugins;
		global $flossy_customizer_notify_recommended_actions;

		global $install_button_label;
		global $activate_button_label;
		global $flossy_deactivate_button_label;

		$this->recommended_actions = isset( $this->config['recommended_actions'] ) ? $this->config['recommended_actions'] : array();
		$this->recommended_plugins = isset( $this->config['recommended_plugins'] ) ? $this->config['recommended_plugins'] : array();

		$this->recommended_actions_title = isset( $this->config['recommended_actions_title'] ) ? $this->config['recommended_actions_title'] : '';
		$this->recommended_plugins_title = isset( $this->config['recommended_plugins_title'] ) ? $this->config['recommended_plugins_title'] : '';
		$this->dismiss_button            = isset( $this->config['dismiss_button'] ) ? $this->config['dismiss_button'] : '';

		$flossy_customizer_notify_recommended_plugins = array();
		$flossy_customizer_notify_recommended_actions = array();

		if ( isset( $this->recommended_plugins ) ) {
			$flossy_customizer_notify_recommended_plugins = $this->recommended_plugins;
		}

		if ( isset( $this->recommended_actions ) ) {
			$flossy_customizer_notify_recommended_actions = $this->recommended_actions;
		}

		$install_button_label    = isset( $this->config['install_button_label'] ) ? $this->config['install_button_label'] : '';
		$activate_button_label   = isset( $this->config['activate_button_label'] ) ? $this->config['activate_button_label'] : '';
		$flossy_deactivate_button_label = isset( $this->config['flossy_deactivate_button_label'] ) ? $this->config['flossy_deactivate_button_label'] : '';

	}

	
	public function setup_actions() {

		// Register the section
		add_action( 'customize_register', array( $this, 'flossy_plugin_notification_customize_register' ) );

		// Enqueue scripts and styles
		add_action( 'customize_controls_enqueue_scripts', array( $this, 'flossy_customizer_notify_scripts_for_customizer' ), 0 );

		/* ajax callback for dismissable recommended actions */
		add_action( 'wp_ajax_quality_customizer_notify_dismiss_action', array( $this, 'flossy_customizer_notify_dismiss_recommended_action_callback' ) );

		add_action( 'wp_ajax_flossy_customizer_notify_dismiss_recommended_plugins', array( $this, 'flossy_customizer_notify_dismiss_recommended_plugins_callback' ) );

	}

	
	public function flossy_customizer_notify_scripts_for_customizer() {

		wp_enqueue_style( 'flossy-customizer-notify-css', get_template_directory_uri() . '/inc/customizer/assets/css/customizer-notify.css', array());

		wp_enqueue_style( 'flossy-plugin-install' );
		wp_enqueue_script( 'flossy-plugin-install' );
		wp_add_inline_script( 'flossy-plugin-install', 'var pagenow = "customizer";' );

		wp_enqueue_script( 'flossy-updates' );

		wp_enqueue_script( 'flossy-customizer-notify-js', get_template_directory_uri() . '/inc/customizer/assets/js/customizer-notify.js', array( 'customize-controls' ));
		wp_localize_script(
			'flossy-customizer-notify-js', 'FlossyCustomizercompanionObject', array(
				'flossy_ajaxurl'            => esc_url(admin_url( 'admin-ajax.php' )),
				'flossy_template_directory' => esc_url(get_template_directory_uri()),
				'flossy_base_path'          => esc_url(admin_url()),
				'flossy_activating_string'  => __( 'Activating', 'flossy' ),
			)
		);

	}

	
	public function flossy_plugin_notification_customize_register( $wp_customize ) {

		
		require_once get_template_directory() . '/inc/customizer/customizer-notify-section.php';

		$wp_customize->register_section_type( 'Flossy_Customizer_Notify_Section' );

		$wp_customize->add_section(
			new Flossy_Customizer_Notify_Section(
				$wp_customize,
				'Flossy-customizer-notify-section',
				array(
					'title'          => $this->recommended_actions_title,
					'plugin_text'    => $this->recommended_plugins_title,
					'dismiss_button' => $this->dismiss_button,
					'priority'       => 0,
				)
			)
		);

	}

	
	public function flossy_customizer_notify_dismiss_recommended_action_callback() {

		global $flossy_customizer_notify_recommended_actions;

		$action_id = ( isset( $_GET['id'] ) ) ? $_GET['id'] : 0;

		echo esc_html($action_id); 

		if ( ! empty( $action_id ) ) {

			
			if ( get_theme_mod( 'flossy_customizer_notify_show' ) ) {

				$flossy_customizer_notify_show_recommended_actions = get_theme_mod( 'flossy_customizer_notify_show' );
				switch ( $_GET['todo'] ) {
					case 'add':
						$flossy_customizer_notify_show_recommended_actions[ $action_id ] = true;
						break;
					case 'dismiss':
						$flossy_customizer_notify_show_recommended_actions[ $action_id ] = false;
						break;
				}
				echo esc_html($flossy_customizer_notify_show_recommended_actions);
				
			} else {
				$flossy_customizer_notify_show_recommended_actions = array();
				if ( ! empty( $flossy_customizer_notify_recommended_actions ) ) {
					foreach ( $flossy_customizer_notify_recommended_actions as $flossy_lite_customizer_notify_recommended_action ) {
						if ( $flossy_lite_customizer_notify_recommended_action['id'] == $action_id ) {
							$flossy_customizer_notify_show_recommended_actions[ $flossy_lite_customizer_notify_recommended_action['id'] ] = false;
						} else {
							$flossy_customizer_notify_show_recommended_actions[ $flossy_lite_customizer_notify_recommended_action['id'] ] = true;
						}
					}
					echo esc_html($flossy_customizer_notify_show_recommended_actions);
				}
			}
		}
		die(); 
	}

	
	public function flossy_customizer_notify_dismiss_recommended_plugins_callback() {

		// global $flossy_customizer_notify_recommended_plugins;
	
		$action_id = ( isset( $_GET['id'] ) ) ? $_GET['id'] : 0;

		echo esc_html($action_id); 

		if ( ! empty( $action_id ) ) {

		if ( get_theme_mod( 'flossy_customizer_notify_show_recommended_plugins' ) ) {
			$flossy_lite_customizer_notify_show_recommended_plugins = get_theme_mod( 'flossy_customizer_notify_show_recommended_plugins' );

			switch ( $_GET['todo'] ) {
				case 'add':
					$flossy_lite_customizer_notify_show_recommended_plugins[ $action_id ] = false;
					break;
				case 'dismiss':
					$flossy_lite_customizer_notify_show_recommended_plugins[ $action_id ] = true;
					break;
			}
			echo esc_html($flossy_lite_customizer_notify_show_recommended_plugins);
			
		} else {
				$flossy_lite_customizer_notify_show_recommended_plugins = array();
				if ( ! empty( $flossy_customizer_notify_recommended_plugins ) ) {
					foreach ( $flossy_customizer_notify_recommended_plugins as $flossy_lite_customizer_notify_recommended_plugin ) {
						if ( $flossy_lite_customizer_notify_recommended_plugin['id'] == $action_id ) {
							$flossy_lite_customizer_notify_show_recommended_plugins[ $flossy_lite_customizer_notify_recommended_plugin['id'] ] = true;
						} else {
							$flossy_lite_customizer_notify_show_recommended_plugins[ $flossy_lite_customizer_notify_recommended_plugin['id'] ] = false;
						}
					}
					echo esc_html($flossy_lite_customizer_notify_show_recommended_plugins);
				}
			}
		}
		die(); 
	}

}
